from vcCommand import *
import os.path
app = getApplication()
some_material = app.Materials[0]
cmd = getCommand()

def OnStart():
  global saveButton
  for p in cmd.Properties:
    cmd.deleteProperty(p)
  column_options = ['', '- Index', '- Quantity', '- LocationX', '- LocationY', '- LocationZ', '- RotationZ', '- RotationY', '- RotationX', '- VCID']
  all_props = [x.Name for c in app.Components for x in c.Properties]
  all_props = list(set(all_props))
  all_props.sort()
  column_options.extend( all_props )
  defaults = ['','- Index', 'Name', '- LocationX', '- LocationY', '- LocationZ', '- RotationZ']
  for i in range(15):
    i+=1
    prop = createProperty(VC_STRING, 'Column %i' % i, VC_PROPERTY_STEP)
    prop.StepValues = column_options
    prop.Value = defaults[i] if i < len(defaults) else ''
  delimProp = createProperty(VC_STRING, 'Settings::Delimiter')
  delimProp.Value = ','
  quantityRuleProp = createProperty(VC_STRING, 'Settings::Quantity rule')
  quantityRuleProp.Value = 'VCID'
  quantityRuleProp.IsVisible = False
  includeProp = createProperty(VC_STRING, 'Settings::Include', VC_PROPERTY_STEP)
  includeProp.StepValues = ['All', 'BOM Checked']
  includeProp.Value = 'All'
  saveButton = createProperty(VC_BUTTON, 'Save')
  saveButton.OnChanged = saveFile
  executeInActionPanel()

def saveFile(arg):
  delimProp = getProperty('Settings::Delimiter')
  delimiter = delimProp.Value
  uri = ""
  ok = True
  savecmd = app.findCommand("dialogSaveFile")
  filefilter = 'CSV table (*.csv)|*.csv|All files (*.*)|*.*'
  savecmd.execute(uri,ok, filefilter, 'Choose File to save BOM')
  if not savecmd.Param_2:
    print "No file selected, aborting command."
    return
  uri = savecmd.Param_1
  fileuri = uri[8:]
  #filebase, filetype = os.path.splitext(fileuri)
  #print filebase
  with open(fileuri, 'w') as output:
    props = [getProperty('Column %i' % (x+1)).Value for x in range(15) if x]
    titles = [x.lstrip('- ') for x in props]
    line = delimiter.join( titles )
    output.write(line + '\n')
    index = 0
    includeProp = getProperty('Settings::Include')
    if includeProp.Value == 'All':
      components = app.Components
    else:
      components = [x for x in app.Components if x.BOM]
    for c in components:
      index += 1
      line = ''
      for pname in props:
        if pname == '- LocationX':
          p = c.WorldPositionMatrix.P
          line += '%.3f' % (p.X)
        elif pname == '- LocationY':
          p = c.WorldPositionMatrix.P
          line += '%.3f' % (p.Y)
        elif pname == '- LocationZ':
          p = c.WorldPositionMatrix.P
          line += '%.3f' % (p.Z)
        elif pname == '- RotationZ':
          p = c.WorldPositionMatrix.WPR
          line += '%.3f' % (p.Z)
        elif pname == '- RotationY':
          p = c.WorldPositionMatrix.WPR
          line += '%.3f' % (p.Y)
        elif pname == '- RotationX':
          p = c.WorldPositionMatrix.WPR
          line += '%.3f' % (p.X)
        elif pname == '- VCID':
          line += c.VCID
        elif pname == '- Index':
          line += str(index)
        elif pname == '- Quantity':
          line += '1'
        elif pname == 'Material':
          line += c.Material.Name if c.Material else '*NULL*'
        else:
          prop = c.getProperty(pname)
          if prop:
            if type(prop.Value) == type(some_material):
              line += prop.Value.Name if prop.Value else '*NULL*'
            elif prop.Type == VC_BOOLEAN:
              line += 'True' if prop.Value else 'False'
            elif prop.Type == VC_REAL:
              line += '%.3f' % (prop.Value)
            elif prop.Type in [VC_INTEGER, VC_STRING]:
              line += str(prop.Value)
            else:
              print 'Non supported property "%s" at component "%s"' % (pname, c.Name)
        line += delimiter
      line += '\n'
      output.write(line)
    output.close()


addState( None )



